SystemOrganization addCategory: #'Xtreams-Http'!

SharedPool subclass: #XTHttpPool
	instanceVariableNames: ''
	classVariableNames: 'CRLF SP Separator Token Whitespace'
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTHttpPool class methodsFor: 'as yet unclassified' stamp: 'cwp 10/21/2011 00:01'!
initialize
	CRLF := String crlf.
	Token :=  #($!! $# $$ $% $& $' $* $+ $- $. $0 $1 $2 $3 $4 $5 $6 $7 $8 $9 $A $B $C $D $E $F $G $H $I $J $K $L $M $N $O $P $Q $R $S $T $U $V $W $X $Y $Z $^ $_ $` $a $b $c $d $e $f $g $h $i $j $k $l $m $n $o $p $q $r $s $t $u $v $w $x $y $z $| $~) asSet.
	Separator := #($( $) $< $> $@ $, $; $: $\ $< $" $> $/ $[ $] $? $= ${ $}) asSet.
	SP := ' '.
	Whitespace := Set 	with: Character space with: Character tab 
	
	! !

Object subclass: #XTChunkBuffer
	instanceVariableNames: 'prefixSize suffixSize bytes position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTChunkBuffer class methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 21:51'!
new: anInteger
	^ self basicNew initializeWithSize: anInteger! !

!XTChunkBuffer methodsFor: 'accessing' stamp: 'cwp 5/2/2011 22:23'!
available
	^ bytes size - suffixSize - position + 1! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:06'!
clear
	| header |
	position := prefixSize + 1.
	header := self size printStringBase: 16.
	bytes replaceFrom: 1 to: header size with: header.
	bytes at: header size + 1 put: 13.
	bytes at: header size + 2 put: 10.
	bytes at: bytes size - 1 put: 13.
	bytes at: bytes size put: 10.
! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/5/2011 00:42'!
close: aWriteStream
	| chunk start |
	chunk := #[48 13 10 13 10].
	start := self prepareFlush.
	self available >= chunk size
		ifTrue:  
			[bytes replaceFrom: position to: position + 4 with: chunk.
			position := position + chunk size.
			aWriteStream write: position - start from: bytes at: start]
		ifFalse:  
			[aWriteStream
				write: position - start from: bytes at: start;
				write: chunk]! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/4/2011 13:59'!
flush: aWriteStream
	| start |
	start := self prepareFlush.
	aWriteStream write: position - start from: bytes at: start! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:36'!
flushIfFull: aWriteStream
	self isFull ifTrue:
		[aWriteStream write: bytes.
		position := prefixSize + 1]! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 22:56'!
initializeWithSize: anInteger
	prefixSize := (anInteger numberOfDigitsInBase: 16) + 2.
	suffixSize := 2.
	bytes := ByteArray new: prefixSize + anInteger + suffixSize.
	self clear! !

!XTChunkBuffer methodsFor: 'testing' stamp: 'cwp 5/2/2011 22:27'!
isFull
	^ self available = 0! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:21'!
prepareFlush
	| header start |
	header := position - prefixSize - 1 printStringBase: 16.
	start := prefixSize - header size - 1.
	bytes
		replaceFrom: start
		to: prefixSize - 2
		with: header
		startingAt: 1.
	self put: 13.
	self put: 10.
	^ start! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 22:46'!
put: aByte
	bytes at: position put: aByte.
	position := position + 1! !

!XTChunkBuffer methodsFor: 'accessing' stamp: 'cwp 5/2/2011 22:54'!
size
	^ bytes size - prefixSize - suffixSize! !

!XTChunkBuffer methodsFor: 'writing' stamp: 'cwp 5/2/2011 22:33'!
streamingWriteInto: aStream
	! !

!XTChunkBuffer methodsFor: 'accessing' stamp: 'cwp 5/2/2011 22:32'!
truncate
	bytes at: position put: 13.
	bytes at: position put: 10.! !

!XTChunkBuffer methodsFor: 'writing' stamp: 'cwp 5/2/2011 23:41'!
write: count from: aByteArray at: start 
	| size |
	size := count min: self available.
	bytes replaceFrom: position to: position + size - 1 with: aByteArray startingAt: start.
	position := position + size.
	^ size	! !

XTWriteStream subclass: #XTChunkingWriteStream
	instanceVariableNames: 'buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 22:59'!
bufferSize: anInteger
	buffer := XTChunkBuffer new: anInteger! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 23:19'!
close
	buffer close: destination.
	destination close.! !

!XTChunkingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 3/17/2011 12:36'!
contentsSpecies
	^ destination contentsSpecies! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 23:00'!
flush
	buffer flush: destination! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/5/2011 00:36'!
on: aDestination
	super on: aDestination.
	self bufferSize: 1024! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 22:16'!
put: aByte
	buffer put: aByte.
	buffer flushIfFull: destination! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 22:25'!
write: count from: bytes at: start
	| limit written position |
	limit := start + count.
	position := start.
	[position < limit] whileTrue:
		[written := buffer write: limit - position from: bytes at: position.
		position := position + written.
		buffer flushIfFull: destination]! !

XTWriteStream subclass: #XTHtmlEntityWriteStream
	instanceVariableNames: ''
	classVariableNames: 'Reserved'
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTHtmlEntityWriteStream class methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 01:29'!
initialize
	Reserved := IdentityDictionary new
		at: $< put: '&lt;';
		at: $> put: '&gt;';
		at: $& put: '&amp;';
		at: $" put: '&quot;';
		yourself! !

!XTHtmlEntityWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 00:47'!
contentsSpecies
	^ String! !

!XTHtmlEntityWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 01:31'!
write: anInteger from: aString at: startIndex
	| limit start index character |
	limit := startIndex + anInteger.
	start := startIndex.
	index := startIndex.
	[index < limit] whileTrue: 
		[character := aString at: index.
		(Reserved includesKey: character) ifTrue: 
			[destination write: index - start from: aString at: start.
			destination write: (Reserved at: character).
			index := index + 1.
			start := index].
		index := index + 1].
	destination write: limit - start from: aString at: start! !

XTWriteStream subclass: #XTPercentEncodingWriteStream
	instanceVariableNames: ''
	classVariableNames: 'Map'
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTPercentEncodingWriteStream class methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:44'!
initialize
	| hex out |
	hex := XTNumberPrinter new.
	hex base: 16; padTo: 2 with: $0; useUppercase.
	Map := Array new: 256.
	0 to: 255 do: 
		[:code || ch |
		ch := Character value: code.
		(self isUnreserved: ch)
			ifTrue: [Map at: code + 1 put: ch asString]
			ifFalse:
				[out := (String new: 3) writing.
				out put: $%.
				hex print: code on: out.
				Map at: code + 1 put: out conclusion]].
		! !

!XTPercentEncodingWriteStream class methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:44'!
isUnreserved: aCharacter
	^ 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~'
		includes: aCharacter! !

!XTPercentEncodingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/19/2011 14:13'!
contentsSpecies
	^ String! !

!XTPercentEncodingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:46'!
put: aCharacter
	destination write: (Map at: aCharacter charCode + 1)! !

!XTPercentEncodingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:33'!
putThrough: aCharacter
	^ destination put: aCharacter! !

!XTPercentEncodingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:52'!
write: count from: collection at: startIndex
	| index limit |
	index := startIndex.
	limit := startIndex + count.
	[[index < limit] whileTrue:
		[self put: (collection at: index).
		index := index + 1]]
			on: Incomplete
			do: [(Incomplete on: collection count: count at: index) raise]
	 ! !

!XTPercentEncodingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:33'!
writeThrough: aString
	^ destination write: aString! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 3/16/2011 00:43'!
chunking
	^ XTChunkingWriteStream on: self.! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 9/11/2011 14:46'!
chunking: anInteger
	^ (XTChunkingWriteStream on: self)
		bufferSize: anInteger! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 8/10/2012 20:51'!
entityEncoding
	^ XTHtmlEntityWriteStream on: self! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 9/24/2011 01:54'!
percentEncoding
	^ XTPercentEncodingWriteStream on: self! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 11/5/2012 00:12'!
severing
	^ self closing: 
		[(destination isKindOf: XTWriteStream) ifTrue: [destination close].
		destination := [:ignore | Incomplete zero raise] writing]! !

XTReadStream subclass: #XTChunkingReadStream
	instanceVariableNames: 'buffer position limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 15:15'!
contentsSpecies 
	^ ByteArray ! !

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 15:50'!
on: aReadStream
	super on: aReadStream.
	buffer := #[].
	position := 1.
	limit := 0.
	! !

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:28'!
read: total into: aCollection at: startIndex
	| amount available count index |
	count := 0.
	index := startIndex.
	[count < total] whileTrue:
		[position > limit ifTrue: [self readChunk].
		available := limit - position + 1.
		available = 0 ifTrue: [(Incomplete on: aCollection count: count at: index) signal].
		amount := total - count min: available.
		aCollection replaceFrom: index to: index + amount - 1 with: buffer startingAt: position.
		position := position + amount.
		count := count + amount.
		index := index + amount].
	^ count
	! !

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 17:04'!
readChunk
	| count digits |
	digits := (source ending: #[13 10]) rest.
	count := (SqNumberParser on: digits asString readStream) nextIntegerBase: 16.
	count > buffer size
		ifTrue: [ buffer := ByteArray new: count ].
	source read: count into: buffer at: 1.
	source ++ 2.	"skip the crlf after the chunk"
	position := 1.
	limit := count! !

XTReadStream subclass: #XTHttpTokenStream
	instanceVariableNames: 'next linefolding'
	classVariableNames: ''
	poolDictionaries: 'XTHttpPool'
	category: 'Xtreams-Http'!

!XTHttpTokenStream methodsFor: 'initialize-release' stamp: 'cwp 10/20/2011 15:58'!
contentsSpecies
	^ Array! !

!XTHttpTokenStream methodsFor: 'accessing' stamp: 'cwp 10/21/2011 00:01'!
get
	| ch |
	ch := self next.
	ch = CR ifTrue: [^ self scanCrLf].
	linefolding := true.
	(Whitespace includes: ch) ifTrue: [^ self scanWhitespace].
	(Separator includes: ch) ifTrue: [^ ch asString].
	(Token includes: ch) ifTrue: [^ self scanToken: ch].
	self error: 'Scan error'! !

!XTHttpTokenStream methodsFor: 'private' stamp: 'cwp 10/20/2011 16:31'!
next
	^ next
		ifNil: [source get]
		ifNotNil: [:ch | next := nil. ch]! !

!XTHttpTokenStream methodsFor: 'initialize-release' stamp: 'cwp 10/20/2011 23:51'!
on: aSource
	super on: aSource.
	linefolding := false.! !

!XTHttpTokenStream methodsFor: 'accessing' stamp: 'cwp 10/20/2011 15:57'!
read: requested into: collection at: startIndex
	| count |
	count := 0.
	[[count < requested] whileTrue:
		[collection at: startIndex + count put: self get.
		count := count + 1]]
			on: Incomplete
			do: [(Incomplete on: collection count: count at: startIndex + count) signal]! !

!XTHttpTokenStream methodsFor: 'private' stamp: 'cwp 10/20/2011 23:18'!
scan: aCharacter matching: valid
	| out ch |
	out := (String new: 4) writing.
	out put: aCharacter.
	[[ch := self next.
	valid includes: ch] whileTrue: [out put: ch].
	next := ch]
		on: Incomplete
		do: [:ignore].
	^ out conclusion! !

!XTHttpTokenStream methodsFor: 'private' stamp: 'cwp 10/22/2011 13:19'!
scanCrLf
	| ch |
	ch := source get.
	ch = LF ifFalse: [self error: 'Expected LF'].
	^ linefolding
		ifTrue: [self scanLws]
		ifFalse: 
			[linefolding := false.
			CRLF]! !

!XTHttpTokenStream methodsFor: 'private' stamp: 'cwp 10/21/2011 00:13'!
scanLws
	next := source get.
	^ (Whitespace includes: next)
		ifTrue: [self scanWhitespace]
		ifFalse: 
			[linefolding := false.
			CRLF]! !

!XTHttpTokenStream methodsFor: 'private' stamp: 'cwp 10/20/2011 23:18'!
scanToken: aCharacter
	^ self scan: aCharacter matching: Token! !

!XTHttpTokenStream methodsFor: 'private' stamp: 'cwp 10/21/2011 00:00'!
scanWhitespace
	[next := source get.
	Whitespace includes: next]
		whileTrue.
	^ SP! !

XTReadStream subclass: #XTPercentDecodingReadStream
	instanceVariableNames: 'ch'
	classVariableNames: 'Map Reserved'
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTPercentDecodingReadStream class methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 13:37'!
initialize
	Reserved := IdentitySet withAll: '!!*''();:@&=+$,/?#[]'.

	Map := Array new: 16.
	1 to: 16 do: [:i | Map at: i put: (Array new: 16)].
	0 to: 255 do:
		[:value || i j |
		j := value rem: 16.
		i := (value quo: 16) rem: 16.
		(Map at: i + 1) at: j + 1 put: (Character value: value)].
	! !

!XTPercentDecodingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 02:27'!
ch
	| tmp |
	tmp := ch.
	ch := nil.
	^ tmp! !

!XTPercentDecodingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:58'!
contentsSpecies
	^ Array! !

!XTPercentDecodingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 02:50'!
decode
	| out |
	out := String new writing.
	[[Reserved includes: ch] whileFalse:
		[ch = $% 
			ifFalse: [ out put: ch ]
			ifTrue:
				[ | i j |
				i := source get digitValue.
				j := source get digitValue.
				out put: ((Map at: i + 1) at: j + 1)].
		ch := source get]]
			on: Incomplete 
			do: [ch := nil].
	^ out conclusion! !

!XTPercentDecodingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2012 15:53'!
get
	
	ch ifNotNil: [^ self ch].  
	ch := source get.
	(Reserved includes: ch) ifTrue: [^ self ch].
	^ self decode! !

!XTPercentDecodingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/19/2011 15:02'!
read: requested into: collection at: startIndex
	| count |
	count := 0.
	[[count < requested] whileTrue:
		[collection at: startIndex + count put: self get.
		count := count + 1]]
			on: Incomplete
			do: [(Incomplete on: collection count: count at: startIndex + count) signal]! !

!XTReadStream methodsFor: '*Xtreams-Http' stamp: 'cwp 9/11/2011 16:02'!
chunking
	^ XTChunkingReadStream on: self! !

!XTReadStream methodsFor: '*Xtreams-Http' stamp: 'cwp 9/12/2011 16:16'!
chunking: anInteger
	"For read streams, the buffer size is specified in the stream,
	so just ignore the parameter."
	
	^ self chunking! !

!XTReadStream methodsFor: '*Xtreams-Http' stamp: 'cwp 10/20/2011 15:39'!
httpTokenizing
	^ XTHttpTokenStream on: self! !

!XTReadStream methodsFor: '*Xtreams-Http' stamp: 'cwp 9/24/2011 01:54'!
percentDecoding
	^ XTPercentDecodingReadStream on: self! !

!XTReadStream methodsFor: '*Xtreams-Http' stamp: 'cwp 11/5/2012 00:11'!
severing
	^ self closing: 
		[(source isKindOf: XTWriteStream) ifTrue: [source close]. 
		source := [Incomplete zero raise] reading]! !
XTHttpPool initialize!
XTHtmlEntityWriteStream initialize!
XTPercentEncodingWriteStream initialize!
XTPercentDecodingReadStream initialize!
